
-----------------------------
-- state
-----------------------------
IDLE_ST					= 0
FOLLOW_ST					= 1
CHASE_ST					= 2
ATTACK_ST					= 3
MOVE_CMD_ST					= 4
STOP_CMD_ST					= 5
ATTACK_OBJECT_CMD_ST			= 6
ATTACK_AREA_CMD_ST			= 7
PATROL_CMD_ST				= 8
HOLD_CMD_ST					= 9
SKILL_OBJECT_CMD_ST			= 10
SKILL_AREA_CMD_ST				= 11
FOLLOW_CMD_ST				= 12
----------------------------

-- Ǝ`
ESCAPE_ST = 101
TAKE_ST = 102
INTERRUPT_ST = 103
FAVOR_ST = 104
-----------

PACKAGE_DIR = "./AI/USER_AI"
PACKAGE_EXT = ".lua"

function import( package )
	if type( package ) == "string" then
		dofile( PACKAGE_DIR.."/"..package..PACKAGE_EXT )
	elseif type( package ) == "table" then
		for k,v in pairs( package ) do
			import( v )
		end
	else assert(nil) end
end

import{
	"table",
	"const",
	"util",
	"playerjobdata",
	"ailib",
	"helper",
	"config",	-- ݒ helper  events ̊Ԃɒu
	"events",
	"revolver",	-- 邭ݒ
}

------------------------------------------
-- global variable
------------------------------------------
MyState				= IDLE_ST	-- ŏ̏Ԃ͋x
MyEnemy				= 0		-- G id
MyDestX				= 0		-- ړIn xW
MyDestY				= 0		-- ړIn yW
MyPatrolX				= 0		-- @ړIn xW
MyPatrolY				= 0		-- @ړIn yW
ResCmdList				= List.new()	-- \R}hXg
MyID					= 0		-- zNX id
MySkill					= 0		-- zNX̃XL
MySkillLevel				= 0		-- zNX̃XLx
------------------------------------------



------------- command process  ---------------------

function	OnMOVE_CMD (x,y)
	
	TraceAI ("OnMOVE_CMD")

	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == GetV(V_MOTION,MyID)) then
		return		-- ړInƌݒn̏ꍇ́AȂ
	end

	RelayMove( MyID, x, y )
	
	MyState = MOVE_CMD_ST
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MySkill = 0

end




function	OnSTOP_CMD ()

	TraceAI ("OnSTOP_CMD")

	if (GetV(V_MOTION,MyID) ~= MOTION_STAND) then
		Move (MyID,GetV(V_POSITION,MyID))
	end
	MyState = IDLE_ST
	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MySkill = 0

end




function	OnATTACK_OBJECT_CMD (id)

	TraceAI ("OnATTACK_OBJECT_CMD")

	MySkill = 0
	MyEnemy = id
	MyState = ATTACK_OBJECT_CMD_ST

end




function	OnATTACK_AREA_CMD (x,y)

	TraceAI ("OnATTACK_AREA_CMD")

	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION,MyID)) then
		Move (MyID,x,y)	
	end
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MyState = ATTACK_AREA_CMD_ST
	
end



function	OnPATROL_CMD (x,y)

	TraceAI ("OnPATROL_CMD")

	MyPatrolX , MyPatrolY = GetV (V_POSITION,MyID)
	MyDestX = x
	MyDestY = y
	Move (MyID,x,y)
	MyState = PATROL_CMD_ST

end




function	OnHOLD_CMD ()

	TraceAI ("OnHOLD_CMD")

	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MyState = HOLD_CMD_ST

end




function	OnSKILL_OBJECT_CMD (level,skill,id)

	TraceAI ("OnSKILL_OBJECT_CMD")
	
	SkillObject( MyID, level, skill, id )
	-- Ō CHASE_ST ɂ SKILL_OBJECT_CMD_ST ɂJڂȂ

end




function	OnSKILL_AREA_CMD (level,skill,x,y)

	TraceAI ("OnSKILL_AREA_CMD")

	Move (MyID,x,y)
	MyDestX = x
	MyDestY = y
	MySkillLevel = level
	MySkill = skill
	MyState = SKILL_AREA_CMD_ST
	
end




function	OnFOLLOW_CMD ()

	local x, y = GetV( V_POSITION, GetV( V_OWNER, MyID ) )
	-- ҋ@߂́Aҋ@ԂƋxԂ݂ɓ]
	if not Contains( { FOLLOW_CMD_ST, FAVOR_ST }, MyState ) then
		MyDestX, MyDestY = GetV( V_POSITION, GetV( V_OWNER, MyID ) )
		MyDestY = MyDestY + 1	-- kɈړ
		Move( MyID, MyDestX, MyDestY )
		
		MyState = FOLLOW_CMD_ST
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("OnFOLLOW_CMD")
	else
		Move( MyID, x, y - 1 )	-- Ɉړ

		MyState = IDLE_ST
		MyDestX, MyDestY = 0, 0 	-- FAVOR_STŎgWZbg
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("FOLLOW_CMD_ST --> IDLE_ST")
	end

end




function	ProcessCommand (msg)

	if		(msg[1] == MOVE_CMD) then
		OnMOVE_CMD (msg[2],msg[3])
		TraceAI ("MOVE_CMD")
	elseif	(msg[1] == STOP_CMD) then
		OnSTOP_CMD ()
		TraceAI ("STOP_CMD")
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then
		OnATTACK_OBJECT_CMD (msg[2])
		TraceAI ("ATTACK_OBJECT_CMD")
	elseif	(msg[1] == ATTACK_AREA_CMD) then
		OnATTACK_AREA_CMD (msg[2],msg[3])
		TraceAI ("ATTACK_AREA_CMD")
	elseif	(msg[1] == PATROL_CMD) then
		OnPATROL_CMD (msg[2],msg[3])
		TraceAI ("PATROL_CMD")
	elseif	(msg[1] == HOLD_CMD) then
		OnHOLD_CMD ()
		TraceAI ("HOLD_CMD")
	elseif	(msg[1] == SKILL_OBJECT_CMD) then
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_OBJECT_CMD")
	elseif	(msg[1] == SKILL_AREA_CMD) then
		OnSKILL_AREA_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_AREA_CMD")
	elseif	(msg[1] == FOLLOW_CMD) then
		OnFOLLOW_CMD ()
		TraceAI ("FOLLOW_CMD")
	end
end




-------------- state process  --------------------

function OnESCAPE_ST()	-- 
	TraceAI ("OnESCAPE_ST")
	
	MySkill = 0
	
	if GetPercentHP( MyID ) > Settings.ESCAPE_HP_PERCENTAGE or GetTargetCount( MyID ) == 0 then	-- ^QĂȂΓȂ
		MyState = IDLE_ST
		return
	end
	
	MyEnemy = GetEnemy( MyID, target_myself )	-- ^QĂԋ߂̓GZbg
	
	-- 3}Xȓ́ił͂ȂƎvjG擾
	local enemys = SelectActor( MyID, target_myself, AllowTargetting,
		function( myid, v ) 	-- GUĂȂtrue
			if GetDistance2( myid, v ) <= 3 then
				return true
			end
			local motion = GetV( V_MOTION, v )	-- 3Zȏ㗣ĂȂړĂ邩`FbN
			return motion == MOTION_MOVE
		end )
	table.foreachi( enemys, function(i,v) TraceAI(v.." "..tostring(GetType(v)).." "..tostring(GetV(V_MOTION,v))) end )
	if table.getn( enemys ) == 0 then	-- Ĝ݂Ȃ
		TraceAI("getn == 0")
		MyState = CHASE_ST 	-- ԋ߂̓GU
		return
	end
	
--	if MyEnemy == 0 then	-- GetTargetCount( MyID ) > 0 łȏケɗ邱Ƃ͂ȂCc
--		MyState = IDLE_ST
--		return
--	end
	local dis = GetDistance2( MyID, MyEnemy )
	if dis == -1 or dis > GetV( V_ATTACKRANGE, MyEnemy ) + 3 then	-- Ƃ肠 ͈+3 Zȏ㗣
		return
	end
	local x, y = CircleTrain( GetV( V_OWNER, MyID ) )
	if x and y then
		Move( MyID, x, y )
	end

end

do
	local nomove
	local enemyX, enemyY
	local timer 	-- NoMoveop̃^C}[
	
	function TakeEnemy()
		if not IsInSearchSight( MyID, MyEnemy ) then	-- G͈͂Oꂽ疳ŃP~Ǐ]
			MyState = FOLLOW_ST
			return true
		end
		if MyEnemy == nomove then	-- ړMob͂̏œ|
			return false
		end
		if not Settings.FIGHT_DISTANCE then
			return false
		end
		local dis = GetDistance2( MyID, GetV( V_OWNER, MyID ) )
		if GetV( V_TARGET, MyEnemy ) == MyID and dis > Settings.FIGHT_DISTANCE then	-- GނĂ
			MyState = TAKE_ST
			enemyX, enemyY = GetV( V_POSITION, MyEnemy )
			timer = timer_start( tick_timer( 500 ) )	-- w~b̊ԂɓGǂĂȂΔړMob
			return true
		end
		return false
	end

	function OnTAKE_ST()
		TraceAI ("OnTAKE_ST")
		
		if not IsAlive( MyEnemy ) or IsOutOfSight( MyID, MyEnemy ) then
			MyState = FOLLOW_ST 	-- EOɏoMob𖳎ĕʂMob̃^QƂȂ悤ɂ (܂ʂȂ)
			return
		end
		
		if GetDistance2( MyID, GetV( V_OWNER, MyID ) ) > Settings.FIGHT_DISTANCE and GetV( V_MOTION, MyID ) ~= MOTION_MOVE then
			MoveToOwnerEx( MyID )
			return
		elseif IsInAttackSight( MyID, MyEnemy ) then
			MyState = ATTACK_ST
			return
		end
		
		TraceAI("Take Object Trace")
		TraceObject( MyEnemy )
		
		if GetV( V_TARGET, MyEnemy ) == 0 then	-- ړMobȂǁAɃ^QOꍇ
			nomove = MyEnemy
			MyState = CHASE_ST
			MyDestX, MyDestY = 0, 0
			TraceAI("OnTAKE_ST -> OnIDLE_ST : This Enemy Is Weak Targetting")
			return
		end
		if not IsNotNoManner( MyID, MyEnemy ) then
			MyState = IDLE_ST
			return
		end
		
		local x, y = GetV( V_POSITION, MyEnemy )
		if timer() and GetV( V_MOTION, MyEnemy ) ~= MOTION_MOVE and ( x == enemyX and y == enemyY ) then	-- ړMob炵ꍇ
			nomove = MyEnemy
			MyState = CHASE_ST
			MyDestX, MyDestY = 0, 0
			TraceAI("OnTAKE_ST -> OnCHASE_ST : Detect NoMove")
			return
		end
		
		if GetDistance2( MyID, MyEnemy ) >= 3 and GetV( V_MOTION, MyID ) == MOTION_MOVE then	-- 3Zȏ㗣ꂽ獡̃Zőҋ@
			Move( MyID, GetV( V_POSITION, MyID ) )
			return
		end
		
	end
end

function OnINTERRUPT_ST()	-- rWQ
	TraceAI ("OnINTERRUPT_ST")
	
	if IsOutOfSight( MyID, MyEnemy ) then	-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		MyEnemy = 0
		MyDestX, MyDestY = 0,0
		TraceAI ("INTERRUPT_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	
	local skill
	if Settings.INTERRUPT_CASTING_MIN_SP and GetV( V_SP, MyID ) >= Eval( Settings.INTERRUPT_CASTING_MIN_SP ) then
		local type = GetV( V_HOMUNTYPE, MyID )
		if IsFamily( type, FILIR ) then
			skill = SKILL_MOONLIGHT
		elseif IsFamily( type, VANILMIRTH ) then
			skill = SKILL_CAPRICE
		end
	end
	
	if skill then
		SkillObject( MyID, 1, skill, MyEnemy )
		TraceAI("INTERRUPT_ST -> INTERRUPT_ST : Use Skill")
	else
		if not IsInAttackSight( MyID, MyEnemy ) then	-- ߂Â
			MyDestX, MyDestY = GetV( V_POSITION, MyEnemy )
			Move( MyID, MyDestX, MyDestY )
			TraceAI("INTERRUPT_ST -> INTERRUPT_ST : Chase for Interrupting")
			return
		end
		
		Attack( MyID, MyEnemy )
		TraceAI("INTERRUPT_ST -> INTERRUPT_ST : Attacking")
	end
	
	if GetV( V_MOTION, MyEnemy ) ~= MOTION_CASTING then	-- rIĂ
		MyState = IDLE_ST
		MyEnemy = 0
		MyDestX, MyDestY = 0,0
		TraceAI ("INTERRUPT_ST -> IDLE_ST : Interrupted")
	end
end

do
	local pos = 0
	local t
	
	function OnFAVOR_ST()	-- ΏۂCɓ  (R[fBO̕֋X MyEnemy ϐΏۂɎgp)
		local object = SearchEnemy( MyID, nil, { nontarget } )	-- U
		if object ~= 0 then 	-- ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			MyDestX, MyDestY = 0, 0
			TraceAI("FAVOR_ST -> CHASE_ST : ATTACKED_IN")
			return
		end
		
		if Settings.MARKING_TIME then
			if not t then
				t = timer( Settings.MARKING_TIME )
				t()
			elseif t() then
				t = nil
				ResetEnemy()
				return
			end
		end
		
		if not AllowMarking( MyEnemy ) then	-- Oɏo
			ResetEnemy()
			return
		end
		
	--	local myx, myy = GetV( V_POSITION, MyID )
	--	if MyDestX ~= 0 and MyDestY ~= 0 and myx ~= MyDestX and myy ~= MyDestY  then	-- ͑
	--		return
	--	end
		if GetV( V_MOTION, MyID ) == MOTION_MOVE then	-- WɒBĂȂ
			return
		end
		
		local x, y = GetV( V_POSITION, MyEnemy )
		if pos == 0 then
			MyDestX, MyDestY = x, y-1
			pos = 1
		elseif pos == 1 then
			MyDestX, MyDestY = x-1, y
			pos = 2
		elseif pos == 2 then
			MyDestX, MyDestY = x, y+1
			pos = 3
		elseif pos == 3 then
			MyDestX, MyDestY = x+1, y
			pos = 0
		end
		Move( MyID, MyDestX, MyDestY )
	end
end

function	OnIDLE_ST ()
	
	TraceAI ("OnIDLE_ST")

	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then		
		ProcessCommandEx( cmd, true )	-- \R}h 
		return 
	end
	
	if GetPercentHP( MyID ) >= Settings.ESCAPE_HP_PERCENTAGE then
		local object = SearchEnemy( MyID )
		if (object ~= 0) then							-- ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
			return
		end
	else	-- ł^QĂȂ΃P~`
		local object = GetV( V_TARGET, GetV( V_OWNER, MyID ) )
		if IsAlive( object ) then
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : Follow Owner")
		end
	end

	if Revolver() then return end	-- 邭ݒ revolver.lua
	local distance = GetDistanceFromOwner(MyID)
	if ( distance > Settings.FOLLOW_DISTANCE or distance == -1) then		-- MYOWNER_OUTSIGNT_IN
		MyState = FOLLOW_ST
		TraceAI ("IDLE_ST -> FOLLOW_ST")
		return;
	end

end




function	OnFOLLOW_ST ()

	TraceAI ("OnFOLLOW_ST")

	if (GetDistanceFromOwner(MyID) <= Settings.FOLLOW_DISTANCE) then		--  DESTINATION_ARRIVED_IN 
		MyState = IDLE_ST
		TraceAI ("FOLLOW_ST -> IDLW_ST")
		return;
	end
	if Settings.FAST_WALK then
		local m = GetV( V_MOTION, MyID )
		if m == MOTION_STAND or m == MOTION_MOVE then
			MoveToOwnerEx( MyID )
			TraceAI ("FOLLOW_ST -> FOLLOW_ST  fast walk")
		end
	else
		if (GetV(V_MOTION,MyID) == MOTION_STAND) then
			MoveToOwner (MyID)
			TraceAI ("FOLLOW_ST -> FOLLOW_ST")
			return;
		end
	end

end


function	OnCHASE_ST ()

	TraceAI ("OnCHASE_ST")
	
	if TakeEnemy() then
		MyDestX, MyDestY = 0,0
		return
	end
	
	if Settings.SEARCH_DISTANCE and GetDistance2( GetV( V_OWNER, MyID ), MyEnemy ) > Settings.SEARCH_DISTANCE then
		ResetEnemy()
		TraceAI ("CHASE_ST -> IDLE_ST : GO")
		return
	end
	
	if Settings.PLAYER_DISTANCE and GetV( V_TARGET, MyEnemy ) <= 0 then	-- G܂N^QĂȂ
		local pc = GetNearestPlayer( MyEnemy )
		if pc ~= 0 and GetDistance2( pc, MyEnemy ) <= Settings.PLAYER_DISTANCE then
			ResetEnemy()
			TraceAI ("CHASE_ST -> IDLE_ST : "..tostring( pc ).." In Player Distance")
			return
		end
	end
	
	if not IsAlive( MyEnemy ) then -- O͂łɎł  AIX3755
		ResetEnemy()
		TraceAI ("CHASE_ST -> IDLE_ST : O͂łɎł")
		return
	end

	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
		ResetEnemy()
		TraceAI ("CHASE_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	if true == IsInAttackSight(MyID,MyEnemy) and GetDistance2( MyID, MyEnemy ) <= Settings.ATTACK_DISTANCE then  -- ENEMY_INATTACKSIGHT_IN
		MyState = ATTACK_ST
		TraceAI ("CHASE_ST -> ATTACK_ST : ENEMY_INATTACKSIGHT_IN")
		return
	end
	
	if not IsNotNoManner( MyID, MyEnemy ) then	-- ڋߒɒNɂƂꂽbX
		ResetEnemy()
		TraceAI ("CHASE_ST -> IDLE_ST : ڋߒɒNɂƂꂽbX")
		return
	end

	local x, y = GetV (V_POSITION,MyEnemy)
	if (MyDestX ~= x or MyDestY ~= y) then			-- DESTCHANGED_IN
		MyDestX, MyDestY = GetV( V_POSITION, MyEnemy )	-- G̍WL
		MoveToNear( MyID, MyEnemy, Settings.ATTACK_DISTANCE )	-- łAۂ2}XꂽꏊɈړ܂`
		TraceAI ("CHASE_ST -> CHASE_ST : DESTCHANGED_IN")
		return
	end
	
	if GetV( V_MOTION, MyID ) ~= MOTION_MOVE then	-- X^bN̏
		MyDestX, MyDestY = 0, 0
		MoveToOwner( MyID )	-- X^bNZEo
		TraceAI("CHASE_ST -> CHASE_ST : Detect Stuck (Reset)")
		return
	end

end


do
	local t = tick_timer( Settings.ATTACK_DELAY )
	function IsAttackDelay()
		return not t()
	end
end

function	OnATTACK_ST ()

	TraceAI ("OnATTACK_ST")
	
	if Settings.FOLLOW_OWNER_TARGETTING then
		local target = GetV( V_TARGET, GetV( V_OWNER, MyID ) )
		if target > 0 and IsEnemy( MyID, target ) then	-- P~̃^QςꍇAɒǏ]
			MyEnemy = target
		end
	end
	
	if GetPercentHP( MyID ) < Settings.ESCAPE_HP_PERCENTAGE then	-- ޔ
	--	if MyEnemy ~= GetV( V_TARGET, GetV( V_OWNER, MyID ) ) then	-- UɃP~̃^Qς̓^QZbg
	--		MyState = IDLE_ST
	--		TraceAI("ATTACK_ST -> IDLE_ST : Owner Target Changed")
	--		return
	--	end
	end
	
	if not IsAlive( MyEnemy ) then   -- ENEMY_DEAD_IN	AIX3755
		MyState = IDLE_ST
		TraceAI ("ATTACK_ST -> IDLE_ST : ENEMY_DEAD_IN")
		return
	end
	
	if not IsNotNoManner( MyID, MyEnemy ) then	-- UɒNɃ^QςI
		MyState = IDLE_ST
		TraceAI ("ATTACK_ST -> IDLE_ST : UɒNɃ^QςI")
		return
	end
	
	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return 
	end
	
	if TakeEnemy() then
		return
	end
	
	if (false == IsInAttackSight(MyID,MyEnemy)) then  -- ENEMY_OUTATTACKSIGHT_IN
		MyState = CHASE_ST
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);
		Move (MyID,MyDestX,MyDestY)
		TraceAI ("ATTACK_ST -> CHASE_ST  : ENEMY_OUTATTACKSIGHT_IN")
		return
	end
	
	if (MySkill == 0) then
		if Settings.ATTACK_MOTION_CANCEL then
			Attack( MyID, MyEnemy )
		elseif not IsAttackDelay() then
			Attack( MyID, MyEnemy )
		end
	else
		SkillObject (MyID,MySkillLevel,MySkill,MyEnemy)
		MySkill = 0
	end
	TraceAI ("ATTACK_ST -> ATTACK_ST  : ENERGY_RECHARGED_IN")
	return


end




function	OnMOVE_CMD_ST ()
	TraceAI ("OnMOVE_CMD_ST")

	local x, y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then				-- DESTINATION_ARRIVED_IN  ړIn
		if Settings.HOLD_ON_MOVE_COMMAND then
			ProcessCommand( { HOLD_CMD } )
		else
			MyState = IDLE_ST
		end
	end
	
	RelayMove( MyID )	-- pړ𑱍s
end




function OnSTOP_CMD_ST ()


end




function OnATTACK_OBJECT_CMD_ST ()	-- gĂȂ̂ ESCAPE_HP_PERCENTAGE ɗLpĂ݂
	TraceAI ("OnATTACK_OBJECT_CMD_ST")

	MyState = CHASE_ST

end




function OnATTACK_AREA_CMD_ST ()

	TraceAI ("OnATTACK_AREA_CMD_ST")

	local object = SearchEnemy( MyID )

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
			MyState = IDLE_ST
	end

end




function OnPATROL_CMD_ST ()

	TraceAI ("OnPATROL_CMD_ST")

	local object = SearchEnemy( MyID )

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("PATROL_CMD_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
		MyDestX = MyPatrolX
		MyDestY = MyPatrolY
		MyPatrolX = x
		MyPatrolY = y
		Move (MyID,MyDestX,MyDestY)
	end

end




function OnHOLD_CMD_ST ()

	TraceAI ("OnHOLD_CMD_ST")
	
	if (MyEnemy ~= 0) then
		local d = GetDistance2(MyEnemy,MyID)	-- C
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE,MyID)) then
				Attack (MyID,MyEnemy)
		else
			MyEnemy = 0;
		end
		return
	end


	local object = SearchEnemy( MyID )
	if (object == 0) then
		return
	end

	MyEnemy = object

end




function OnSKILL_OBJECT_CMD_ST ()	-- ςp~
	TraceAI ("OnSKILL_OBJECT_CMD_ST")
	
--	MyState = CHASE_ST
end




function OnSKILL_AREA_CMD_ST ()

	TraceAI ("OnSKILL_AREA_CMD_ST")

	local x , y = GetV (V_POSITION,MyID)
	if (GetDistance(x,y,MyDestX,MyDestY) <= GetV(V_SKILLATTACKRANGE,MyID,MySkill)) then	-- DESTARRIVED_IN
		SkillGround (MyID,MySkillLevel,MySkill,MyDestX,MyDestY)
		MyState = IDLE_ST
		MySkill = 0
	end

end







function OnFOLLOW_CMD_ST ()

	TraceAI ("OnFOLLOW_CMD_ST")

	local ownerX, ownerY, myX, myY
	ownerX, ownerY = GetV (V_POSITION,GetV(V_OWNER,MyID)) -- 
	myX, myY = GetV (V_POSITION,MyID)					  --  
	
	local d = GetDistance (ownerX,ownerY,myX,myY)

	if ( d <= Settings.FOLLOW_DISTANCE ) then									-- 3Zȉ̋Ȃ
		return 
	end

	local motion = GetV (V_MOTION,MyID)
	if Settings.FAST_WALK then
		MoveToOwnerEx( MyID )
	else
		if (motion == MOTION_MOVE) then					-- ړ
			d = GetDistance (ownerX, ownerY, MyDestX, MyDestY)
			if ( d > Settings.FOLLOW_DISTANCE ) then									-- 4Zȏ̋Ȃ
				MoveToOwner (MyID)
				MyDestX = ownerX
				MyDestY = ownerY
				return
			end
		else									-- ̓ 
			MoveToOwner (MyID)
			MyDestX = ownerX
			MyDestY = ownerY
			return
		end
	end
	
end




function AI(myid)

	MyID = myid

	if (MyState == ATTACK_ST and Settings.MULTI_ATTACK >= 3) then
		OnATTACK_ST ()	-- LiveRO AI thread 3 No.54-55
	end

	local msg	= GetMsg (myid)			-- command
	local rmsg	= GetResMsg (myid)		-- reserved command
	
	if msg[1] == NONE_CMD then
		if rmsg[1] ~= NONE_CMD then
			if List.size(ResCmdList) < 10 then
				List.pushright (ResCmdList,rmsg) -- \R}hۑ
			end
		end
	else
		List.clear (ResCmdList)	-- VR}h͂ꂽA\R}h͍폜
		ProcessCommandEx( msg, false )	-- R}h 
	end
	
--	DispatchKeyMsgs()
	
	DispatchEvents( EVENT_BEGIN_STATE )

	-- ԏ 
 	if (MyState == IDLE_ST) then
		OnIDLE_ST ()
	end
	if (MyState == CHASE_ST) then
		OnCHASE_ST ()
	end
	if (MyState == ATTACK_ST) then
		OnATTACK_ST ()
	elseif (MyState == FOLLOW_ST) then
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then
		OnMOVE_CMD_ST ()
	elseif (MyState == STOP_CMD_ST) then
		OnSTOP_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == ATTACK_AREA_CMD_ST) then
		OnATTACK_AREA_CMD_ST ()
	elseif (MyState == PATROL_CMD_ST) then
		OnPATROL_CMD_ST ()
	elseif (MyState == HOLD_CMD_ST) then
		OnHOLD_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_AREA_CMD_ST) then
		OnSKILL_AREA_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then
		OnFOLLOW_CMD_ST ()

	elseif MyState == ESCAPE_ST then
		OnESCAPE_ST()
	elseif MyState == TAKE_ST then
		OnTAKE_ST()
	elseif MyState == INTERRUPT_ST then
		OnINTERRUPT_ST()
	elseif MyState == FAVOR_ST then
		OnFAVOR_ST()
		
	end
	
	DispatchEvents( EVENT_END_STATE )

	if (MyState == ATTACK_ST and Settings.MULTI_ATTACK >= 2) then
		OnATTACK_ST ()	-- LiveRO AI thread 3 No.54-55
	end

	ResetRevolver ()	-- 邭ݒ revolver.lua
end

